from distutils.core import setup, Extension
from distutils.sysconfig import get_python_lib
from distutils.command.install_data import install_data
import os, sys, re, glob

class SnapPea_install_data(install_data):

    def finalize_options (self):
        self.set_undefined_options('install',
                                   ('install_lib', 'install_dir'),
                                   ('root', 'root'),
                                   ('force', 'force'),
                                  )
        print self.install_dir
    
base_code = glob.glob(os.path.join("SnapPeaC","kernel_code","*.c"))
unix_code = glob.glob(os.path.join("SnapPeaC","unix_kit","*.c"))
unix_code.remove(os.path.join("SnapPeaC","unix_kit",'unix_UI.c'))
addl_code = glob.glob(os.path.join("SnapPeaC", "addl_code", "*.c"))
cplusplus_code = glob.glob(os.path.join("SnapPeaC", "addl_code", "*.cc"))
code  = ["SnapPeaC/SnapPeaC.c"] + base_code + unix_code + addl_code + cplusplus_code
data_dir ="SnapPea/manifolds"
links  = glob.glob(os.path.join("SnapPea","manifolds","ChristyLinks","L*"))
closed = glob.glob(os.path.join("SnapPea","manifolds","ClosedCensusData","Cl*"))
cusped = glob.glob(os.path.join("SnapPea","manifolds","CuspedCensusData","t*"))
knots  = glob.glob(os.path.join("SnapPea","manifolds","HTWKnots","*.gz"))

# for debugging add 'extra_compile_args = ["-g"]' to the below 
SnapPeaC = Extension("SnapPea.SnapPeaC", sources = code,
                     include_dirs = ["SnapPeaC/headers", "SnapPeaC/unix_kit"],
                     define_macros=[("DEBUG_MALLOC", 0)])

setup( name = "SnapPea",
       version = "",
       description = "Fun with hyperbolic 3-manifolds",
       cmdclass = {"install_data" : SnapPea_install_data},
       packages=["SnapPea","SnapPea/manifolds"],
       ext_modules = [SnapPeaC],
       data_files = [(data_dir+"/ClosedCensusData", closed),
                     (data_dir+"/CuspedCensusData", cusped),
                     (data_dir+"/ChristyLinks", links),
                     (data_dir+"/HTWKnots", knots),
                     ]
       )



       


